#!/usr/bin/env python3

ECPN = {
        2: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        3: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        4: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        5: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        6: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        7: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        8: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        9: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        10: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        11: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        12: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        13: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        14: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        15: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        16: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        17: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        18: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        19: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        20: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        21: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        22: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        23: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        24: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12),
        25: (1, 2, 3, 5, 6, 7, 9, 10, 11, 12)}

EFE = {
        3: (1, 2),
        4: (1, 2),
        5: (1, 2),
        6: (1, 2),
        7: (1, 2),
        8: (1, 2),
        9: (1, 2),
        10: (1, 2),
        11: (1, 2),
        12: (1, 2),
        13: (1, 2),
        14: (1, 2),
        15: (1, 2),
        16: (1, 2),
        17: (1, 2),
        18: (1, 2),
        19: (1, 2),
        20: (1, 2),
        21: (1, 2),
        22: (1, 2),
        23: (1, 2),
        24: (1, 2),
        25: (1, 2),
        26: (1, 2),
        27: (1, 2),
        28: (1, 2),
        29: (1, 2),
        32: (1, 2),
        33: (1, 2),
        34: (1, 2),
        35: (1, 2),
        36: (1, 2),
        37: (1, 2),
        38: (1, 2),
        39: (1, 2),
        40: (1, 2),
        41: (1, 2),
        42: (1, 2),
        43: (1, 2),
        44: (1, 2),
        45: (1, 2),
        46: (1, 2),
        47: (1, 2),
        48: (1, 2),
        51: (1, 2),
        52: (1, 2),
        53: (1, 2),
        54: (1, 2),
        55: (1, 2),
        56: (1, 2),
        57: (1, 2),
        58: (1, 2),
        59: (1, 2),
        60: (1, 2),
        61: (1, 2),
        62: (1, 2),
        63: (1, 2),
        64: (1, 2),
        65: (1, 2),
        66: (1, 2),
        67: (1, 2),
        68: (1, 2),
        69: (1, 2),
        70: (1, 2),
        72: (1, 2),
        74: (1, 2),
        76: (1, 2),
        77: (1, 2)}

BAL = {
       5: (1, 2),
       6: (1, 2),
       7: (1, 2),
       8: (1, 2),
       10: (1, 2),
       11: (1, 2),
       12: (1, 2),
       13: (1, 2),
       14: (1, 2),
       17: (1, 2),
       18: (1, 2),
       19: (1, 2),
       21: (1, 2),
       22: (1, 2),
       23: (1, 2),
       26: (1, 2),
       28: (1, 2),
       29: (1, 2),
       30: (1, 2),
       31: (1, 2),
       32: (1, 2),
       34: (1, 2),
       35: (1, 2),
       36: (1, 2),
       38: (1, 2),
       39: (1, 2),
       40: (1, 2),
       41: (1, 2),
       49: (1, 2),
       50: (1, 2),
       52: (1, 2),
       53: (1, 2),
       54: (1, 2),
       55: (1, 2),
       56: (1, 2),
       57: (1, 2),
       59: (1, 2),
       60: (1, 2),
       61: (1, 2),
       62: (1, 2),
       65: (1, 2),
       67: (1, 2),
       68: (1, 2),
       69: (1, 2),
       70: (1, 2),
       71: (1, 2),
       74: (1, 2),
       75: (1, 2),
       77: (1, 2),
       78: (1, 2),
       79: (1, 2),
       80: (1, 2),
       81: (1, 2),
       83: (1, 2),
       84: (1, 2),
       85: (1, 2),
       86: (1, 2),
       87: (1, 2),
       88: (1, 2)}

PIG = {
       4: (1, 2),
       5: (1, 2),
       6: (1, 2),
       7: (1, 2),
       8: (1, 2),
       12: (1, 2),
       13: (1, 2),
       15: (1, 2),
       16: (1, 2),
       17: (1, 2),
       19: (1, 2),
       20: (1, 2),
       21: (1, 2),
       23: (1, 2),
       24: (1, 2),
       25: (1, 2),
       27: (1, 2),
       28: (1, 2),
       29: (1, 2),
       30: (1, 2),
       31: (1, 2),
       32: (1, 2),
       37: (1, 2),
       38: (1, 2),
       40: (1, 2),
       41: (1, 2),
       42: (1, 2),
       43: (1, 2),
       45: (1, 2),
       46: (1, 2),
       51: (1, 2),
       52: (1, 2),
       54: (1, 2)}


N2 = {
      24: (2, 3, 4, 5),
      25: (2, 3, 4, 5),
      26: (2, 3, 4, 5),
      27: (2, 3, 4, 5),
      28: (2, 3, 4, 5),
      29: (2, 3, 4, 5),
      30: (2, 3, 4, 5),
      31: (2, 3, 4, 5),
      32: (2, 3, 4, 5),
      33: (2, 3, 4, 5)}

N3 = {
      4: (1 ,),
      5: (1 ,),
      6: (1 ,),
      7: (1 ,),
      8: (1 ,),
      12: (1 ,),
      13: (1 ,),
      14: (1 ,),
      15: (1 ,),
      16: (1 ,),
      17: (1 ,),
      18: (1 ,),
      19: (1 ,)}

N5 = {
        6: (1, 2, 3, 4, 5),
        7: (1, 2, 3, 4, 5),
        8: (1, 2, 3, 4, 5),
        9: (1, 2, 3, 4, 5),
        10: (1, 2, 3, 4, 5),
        11: (1, 2, 3, 4, 5),
        12: (1, 2, 3, 4, 5),
        13: (1, 2, 3, 4, 5),
        18: (1, 2, 3, 4, 5),
        19: (1, 2, 3, 4, 5),
        20: (1, 2, 3, 4, 5),
        21: (1, 2, 3, 4, 5),
        22: (1, 2, 3, 4, 5),
        23: (1, 2, 3, 4, 5),
        24: (1, 2, 3, 4, 5),
        25: (1, 2, 3, 4, 5),
        30: (1, 2, 3, 4, 5),
        31: (1, 2, 3, 4, 5),
        32: (1, 2, 3, 4, 5 ),
        33: (1, 2, 3, 4, 5),
        34: (1, 2, 3, 4, 5),
        35: (1, 2, 3, 4, 5),
        36: (1, 2, 3, 4, 5),
        37: (1, 2, 3, 4, 5),
        42: (1, 2, 3, 4, 5),
        43: (1, 2, 3, 4, 5),
        44: (1, 2, 3, 4, 5),
        45: (1, 2, 3, 4, 5),
        46: (1, 2, 3, 4, 5),
        47: (1, 2, 3, 4, 5),
        48: (1, 2, 3, 4, 5),
        49: (1, 2, 3, 4, 5),
        54: (1, 2, 3),
        55: (1, 2, 3),
        56: (1, 2, 3),
        57: (1, 2, 3),
        58: (1, 2, 3),
        59: (1, 2, 3),
        60: (1, 2, 3),
        61: (1, 2, 3),
        66: (1, 2, 3),
        67: (1, 2, 3),
        68: (1, 2, 3),
        69: (1, 2, 3),
        70: (1, 2, 3),
        71: (1, 2, 3),
        72: (1, 2, 3),
        73: (1, 2, 3)}

N5_1_offset = {'length': 20,
                'row': 79,
                'cols': (1, )}

N5_2_offset = {'length': 20,
                'row': 206,
                'cols': (1, 5, 6, 7)}



N6= {
        6: (1, 2, 3, 4, 5 ),
        7: (1, 2, 3, 4, 5 ),
        8: (1, 2, 3, 4, 5 ),
        9: (1, 2, 3, 4, 5 ),
        10: (1, 2, 3, 4, 5 ),
        11: (1, 2, 3, 4, 5 ),
        12: (1, 2, 3, 4, 5 ),
        13: (1, 2, 3, 4, 5 ),
        14: (1, 2, 3, 4, 5 ),
        15: (1, 2, 3, 4, 5 ),
        16: (1, 2, 3, 4, 5 ),
        21: (1, 2, 3, 4, 5 ),
        22: (1, 2, 3, 4, 5 ),
        23: (1, 2, 3, 4, 5 ),
        24: (1, 2, 3, 4, 5 ),
        25: (1, 2, 3, 4, 5 ),
        26: (1, 2, 3, 4, 5 ),
        27: (1, 2, 3, 4, 5 ),
        28: (1, 2, 3, 4, 5 ),
        29: (1, 2, 3, 4, 5 ),
        30: (1, 2, 3, 4, 5 ),
        31: (1, 2, 3, 4, 5 ),
        36: (1, 2, 3, 4, 5 ),
        37: (1, 2, 3, 4, 5 ),
        38: (1, 2, 3, 4, 5 ),
        39: (1, 2, 3, 4, 5 ),
        40: (1, 2, 3, 4, 5 ),
        41: (1, 2, 3, 4, 5 ),
        42: (1, 2, 3, 4, 5 ),
        43: (1, 2, 3, 4, 5 ),
        44: (1, 2, 3, 4, 5 ),
        45: (1, 2, 3, 4, 5 ),
        46: (1, 2, 3, 4, 5 ),
        51: (1, 2, 3, 4, 5 ),
        52: (1, 2, 3, 4, 5 ),
        53: (1, 2, 3, 4, 5 ),
        54: (1, 2, 3, 4, 5 ),
        55: (1, 2, 3, 4, 5 ),
        56: (1, 2, 3, 4, 5 ),
        57: (1, 2, 3, 4, 5 ),
        58: (1, 2, 3, 4, 5 ),
        59: (1, 2, 3, 4, 5 ),
        60: (1, 2, 3, 4, 5 ),
        61: (1, 2, 3, 4, 5 ),
        66: (1, 2, 3),
        67: (1, 2, 3),
        68: (1, 2, 3),
        69: (1, 2, 3),
        70: (1, 2, 3),
        71: (1, 2, 3),
        72: (1, 2, 3),
        73: (1, 2, 3),
        74: (1, 2, 3),
        75: (1, 2, 3),
        76: (1, 2, 3),
        81: (1, 2, 3),
        82: (1, 2, 3),
        83: (1, 2, 3),
        84: (1, 2, 3),
        85: (1, 2, 3),
        86: (1, 2, 3),
        87: (1, 2, 3),
        88: (1, 2, 3),
        89: (1, 2, 3),
        90: (1, 2, 3),
        91: (1, 2, 3),
        98: (1, ),
        99: (1, ),
        100: (1, ),
        101: (1, ),
        102: (1, ),
        103: (1, ),
        104: (1, ),
        105: (1, ),
        106: (1, ),
        107: (1, ),
        138: (1, 2, (3, 'DATE'), 4),
        139: (1, 2, (3, 'DATE'), 4),
        140: (1, 2, (3, 'DATE'), 4),
        141: (1, 2, (3, 'DATE'), 4),
        142: (1, 2, (3, 'DATE'), 4),
        143: (1, 2, (3, 'DATE'), 4),
        144: (1, 2, (3, 'DATE'), 4),
        145: (1, 2, (3, 'DATE'), 4),
        146: (1, 2, (3, 'DATE'), 4),
        147: (1, 2, (3, 'DATE'), 4),
        148: (1, 2, (3, 'DATE'), 4),}

N6_1_offset = {'length': 20,
                'row': 116,
                'cols': (1, 2 )}

N6_2_offset = {'length': 20,
                'row': 229,
                'cols': (1, 5, 6, 7)}

N7 = {
        6: (1, 2, 3, 4, 5),
        7: (1, 2, 3, 4, 5),
        8: (1, 2, 3, 4, 5),
        13: (1, 2, 3, 4, 5),
        14: (1, 2, 3, 4, 5),
        15: (1, 2, 3, 4, 5),
        20: (1, 2, 3, 4, 5),
        21: (1, 2, 3, 4, 5),
        22: (1, 2, 3, 4, 5),
        27: (1, 2, 3 ),
        28: (1, 2, 3 ),
        29: (1, 2, 3 ),
        34: (1, 2, 3 ),
        35: (1, 2, 3 ),
        36: (1, 2, 3 )}

N8 = {
        7: (1, 2, 3),
        8: (1, 2, 3),
        9: (1, 2, 3),
        10: (1, 2, 3),
        11: (1, 2, 3),
        12: (1, 2, 3),
        13: (1, 2, 3),
        15: (1, 2, 3),
        16: (1, 2, 3),
        17: (1, 2, 3),
        18: (1, 2, 3),
        19: (1, 2, 3),
        20: (1, 2, 3),
        24: (1, 2, 3),
        25: (1, 2, 3),
        26: (1, 2, 3),
        27: (1, 2, 3),
        28: (1, 2, 3),
        29: (1, 2, 3),
        30: (1, 2, 3),
        31: (1, 2, 3),
        32: (1, 2, 3),
        36: (1, 2, 3),
        37: (1, 2, 3),
        38: (1, 2, 3),
        39: (1, 2, 3),
        40: (1, 2, 3),
        41: (1, 2, 3),
        42: (1, 2, 3),
        43: (1, 2, 3),
        44: (1, 2, 3),
        48: (1, 2, 3),
        49: (1, 2, 3),
        50: (1, 2, 3),
        51: (1, 2, 3),
        52: (1, 2, 3),
        53: (1, 2, 3),
        54: (1, 2, 3),
        55: (1, 2, 3),
        56: (1, 2, 3),
        61: (1, 2, 3),
        62: (1, 2, 3),
        63: (1, 2, 3),
        65: (1, 2, 3),
        66: (1, 2, 3),
        67: (1, 2, 3),
        72: (1, 2, 3),
        73: (1, 2, 3),
        74: (1, 2, 3),
        76: (1, 2, 3),
        77: (1, 2, 3),
        78: (1, 2, 3),
        85: (1, 2, 3, 4, 5),
        86: (1, 2, 3, 4, 5),
        87: (1, 2, 3, 4, 5),
        88: (1, 2, 3, 4, 5),
        89: (1, 2, 3, 4, 5),
        90: (1, 2, 3, 4, 5),
        92: (1, 2, 3, 4, 5),
        93: (1, 2, 3, 4, 5),
        94: (1, 2, 3, 4, 5),
        95: (1, 2, 3, 4, 5),
        96: (1, 2, 3, 4, 5),
        97: (1, 2, 3, 4, 5),
        136: (1, 2, 3, 4),
        137: (1, 2, 3, 4),
        138: (1, 2, 3, 4),
        139: (1, 2, 3, 4),
        140: (1, 2, 3, 4),
        141: (1, 2, 3, 4),
        142: (1, 2, 3, 4),
        143: (1, 2, 3, 4),
        144: (1, 2, 3, 4),
        149: (1, 2),
        150: (1, 2),
        151: (1, 2),
        152: (1, 2),
        153: (1, 2),
        154: (1, 2),
        156: (1, 2),
        157: (1, 2),
        158: (1, 2),
        159: (1, 2),
        160: (1, 2)}

N8_1_offset = {'length': 20,
             'row': 112,
             'cols': (2, 3, 4, 5)}

N8_2_offset = {'length': 20,
             'row': 112,
             'cols': (6, 7, 8, 9)}

N8_3_offset = {'length': 20,
             'row': 112,
             'cols': (10, 11, 12, 13, 14)}

N9_offset = {'length': 20,
                'row': 6,
                'cols': (1, )}


N10_offset = {'length': 20,
                'row': 6,
                'cols': (1, 2, 3, (4, 'STRING'))}


N11_offset = {'length': 20,
                'row': 6,
                'cols': (1, )}

N12 = {6: (2, )}

N12_1_offset = {'length': 20,
                'row': 9,
                'cols': (1, )}

N12_2_offset = {'length': 20,
                'row': 40,
                'cols': (1, (3, 'STRING'))}

N13 = {
      7: (1, 2, 3),
      8: (1, 2, 3),
      9: (1, 2, 3),
      10: (1, 2, 3),
      11: (1, 2, 3),
      12: (1, 2, 3),
      13: (1, 2, 3),
      15: (1, 2, 3),
      16: (1, 2, 3),
      17: (1, 2, 3),
      18: (1, 2, 3),
      19: (1, 2, 3),
      20: (1, 2, 3),
      21: (1, 2, 3),
      27: (1, 2, 3),
      28: (1, 2, 3),
      29: (1, 2, 3),
      30: (1, 2, 3),
      31: (1, 2, 3),
      32: (1, 2, 3),
      33: (1, 2, 3),
      35: (1, 2, 3),
      36: (1, 2, 3),
      37: (1, 2, 3),
      38: (1, 2, 3),
      39: (1, 2, 3),
      40: (1, 2, 3),
      41: (1, 2, 3),
      47: (1, 2, 3),
      48: (1, 2, 3),
      49: (1, 2, 3),
      50: (1, 2, 3),
      51: (1, 2, 3),
      52: (1, 2, 3),
      53: (1, 2, 3),
      55: (1, 2, 3),
      56: (1, 2, 3),
      57: (1, 2, 3),
      58: (1, 2, 3),
      59: (1, 2, 3),
      60: (1, 2, 3),
      61: (1, 2, 3),
      67: (1, 2, 3),
      68: (1, 2, 3),
      69: (1, 2, 3),
      70: (1, 2, 3),
      71: (1, 2, 3),
      72: (1, 2, 3),
      73: (1, 2, 3),
      75: (1, 2, 3),
      76: (1, 2, 3),
      77: (1, 2, 3),
      78: (1, 2, 3),
      79: (1, 2, 3),
      80: (1, 2, 3),
      81: (1, 2, 3),
      88: (1, 2, 3),
      89: (1, 2, 3),
      90: (1, 2, 3),
      91: (1, 2, 3),
      92: (1, 2, 3),
      96: (1, 2, 3),
      97: (1, 2, 3),
      98: (1, 2, 3),
      99: (1, 2, 3),
      100: (1, 2, 3),
      106: (1, 2, 3, 4, 5, 6),
      134: (3, ),
      135: (3, ),
      139: (1, 2),
      140: (1, 2)}


N13_1_offset = {'length': 20,
                'row': 109,
                'cols': (1, 2, 3, 4, 5, 6)}

N13_2_offset = {'length': 20,
                'row': 145,
                'cols': (1, 2)}

N14_1_offset = {'length': 20,
                'row': 5,
                'cols': (1, 2, 3, 4, 5)}

N14_2_offset = {'length': 20,
                'row': 37,
                'cols': ((1, 'DATE'), (2, 'STRING'), 3)}

N15_offset = {'length': 20,
                'row': 5,
                'cols': (1, )}

N16 = {
      30: (3, 4),
      31: (3, 4),
      32: (3, 4),
      33: (3, 4),
      34: (3, 4),
      35: (3, 4),
      36: (3, 4),
      37: (3, 4),
      38: (3, 4),
      39: (3, 4),
      40: (3, 4),
      41: (3, 4),
      57: (1, 2),
      58: (1, 2),
      62: (1, 2),
      63: (1, 2),
      64: (1, 2),
      65: (1, 2),
      66: (1, 2),
      67: (1, 2),
      68: (1, 2),
      69: (1, 2),
      70: (1, 2),
      71: (1, 2),
      72: (1, 2),
      76: (1, 2),
      77: (1, 2),
      78: (1, 2),
      82: (1, 2),
      83: (1, 2),
      84: (1, 2),
      85: (1, 2),
      86: (1, 2),
      88: (1, 2),
      89: (1, 2),
      90: (1, 2),
      91: (1, 2),
      92: (1, 2),
      96: (1, ),
      97: (1, ),
      101: (1, ),
      102: (1, ),
      103: (1, ),
      107: (1, ),
      108: (1, ),
      109: (1, ),
      110: (1, ),
      111: (1, ),
      112: (1, ),
      113: (1, ),
      114: (1, ),
      115: (1, ),
      168: (1, ),
      169: (1, )}

N16_1_offset = {'length': 20,
                'row': 6,
                'cols': (1, 2, 3)}

N16_2_offset = {'length': 20,
                'row': 122,
                'cols': (1,)}

N16_3_offset = {'length': 20,
                'row': 145,
                'cols': (1,)}

N17 = {
      5: (1, 2, 3, 4, 5),
      6: (1, 2, 3, 4, 5),
      21: (1,)}

N17_offset = {'length': 20,
                'row': 21,
                'cols': ((1, 'STRING'),)}

N18 = {
      6: (1,),
      7: (1,),
      8: (1,),
      9: (1,),
      10: (1,),
      11: (1,),
      12: (1,),
      13: (1,),
      14: (1,),
      15: (1,)}

N18_1_offset = {'length': 20,
                'row': 21,
                'cols': (1, 2)}

N18_2_offset = {'length': 20,
                'row': 44,
                'cols': (1,)}

N18_3_offset = {'length': 20,
                'row': 69,
                'cols': (1, 2)}

N18_4_offset = {'length': 20,
                'row': 94,
                'cols': (1, 2)}

N19 = {
      31: (1, 2, 3, 4, 5),
      32: (1, 2, 3, 4, 5),
      33: (1, 2, 3, 4, 5),
      34: (1, 2, 3, 4, 5),
      35: (1, 2, 3, 4, 5),
      37: (1, 2, 3, 4, 5),
      38: (1, 2, 3, 4, 5),
      39: (1, 2, 3, 4, 5),
      40: (1, 2, 3, 4, 5),
      41: (1, 2, 3, 4, 5),
      43: (1, 2, 3, 4, 5),
      44: (1, 2, 3, 4, 5),
      45: (1, 2, 3, 4, 5),
      46: (1, 2, 3, 4, 5),
      48: (1, 2, 3, 4, 5),
      49: (1, 2, 3, 4, 5),
      50: (1, 2, 3, 4, 5),
      51: (1, 2, 3, 4, 5),
      52: (1, 2, 3, 4, 5),
      57: (1, 2, 3, 4, 5),
      58: (1, 2, 3, 4, 5),
      59: (1, 2, 3, 4, 5),
      60: (1, 2, 3, 4, 5),
      61: (1, 2, 3, 4, 5),
      62: (1, 2, 3, 4, 5),
      63: (1, 2, 3, 4, 5),
      64: (1, 2, 3, 4, 5),
      65: (1, 2, 3, 4, 5)}
      
N19_1_offset = {'length': 20,
                'row': 117,
                'cols': (2,)}

N19_2_offset = {'length': 20,
                'row': 143,
                'cols': (2,)}

N19_3_offset = {'length': 20,
                'row': 169,
                'cols': (2,)}

N19_4_offset = {'length': 20,
                'row': 195,
                'cols': (2,)}

N19_5_offset = {'length': 20,
                'row': 221,
                'cols': (2,)}

N19_6_offset = {'length': 20,
                'row': 247,
                'cols': (2,)}

N20_1_offset = {'length': 20,
                'row': 4,
                'cols': (2,)}

N20_2_offset = {'length': 20,
                'row': 27,
                'cols': (2,)}
                
                


RANGES_MEM = {'N1': ('A6:F6', 'A8:A8', 'A10:A10','A17:F17', 'A19:F19',
                      'A21:A21', 'B25:B26'),
              'N2': ('A8:A8', 'A17:A17', 'C24:F33', 'A36:A36', 'A45:A45',
                     'A54:A54', 'A63:A63', 'A75:A75', 'A86:A86', 'A95:A95',
                     'A104:A104', 'A113:A113', 'A122:A122', 'A134:A134',
                     'A143:A143', 'A152:A152'),
              'N3': ('B4:B8', 'A8:A8', 'B12:B19', 'A19:A19', 'A27:A27'),
              'N4': ('A2:A2',),
              'N5': ('B6:E13', 'B18:E25', 'B30:E37', 'B54:D61',
                    'B66:D73', 'A79:B98', 'B104:B105', 'A110:A110',
                    'A118:A118', 'A126:A126', 'A134:A134', 'A142:A142', 'B151:E158',
                    'A164:A164', 'A172:A172', 'A180:A180', 'A191:A191',
                    'A199:A199', 'A206:H225', 'A231:A231', 'A239:A239'),
              'N6': ('B6:E16', 'B21:E31', 'B36:E46', 'B66:D76', 'B81:D91',
                     'B98:B107', 'A110:A110', 'A116:C135', 'B138:E148',
                     'A155:A155', 'A163:A163', 'A171:A171', 'A179:A179',
                     'B188:E197', 'A203:A203', 'A214:A214', 'A222:A222',
                     'A229:H248', 'A254:A254', 'A262:A262'),
              'N7': ('B6:E8', 'B13:E15', 'B27:D29', 'B34:D36', 'B42:B42',
                     'D42:D42', 'A50:A50', 'A58:A58'),
              'N8': ('B7:C13', 'B15:C20', 'B24:C32', 'B36:C44', 'B48:D56',
                     'B61:D63', 'B65:D67', 'B72:D74', 'B76:D78',
                     'B85:E90', 'B92:E97', 'A104:A104', 'A112:N131',
                     'B136:E144', 'B149:C154', 'B156:C160', 'A166:A166',
                     'A177:A177', 'A185:A185', 'A193:A193', 'A201:A201',
                     'A209:A209'),
             'N9': ('A6:B25', 'B29:E29', 'B35:E35', 'A38:A38', 'A46:A46',
                    'A54:A54', 'A65:A65', 'A73:A73'),
             'N10': ('A6:B25', ),
             'N11': ('A6:B25', ),
             'N12': ('A6:C6', 'A9:B28', 'A34:A34', 'A40:D59', 'A65:A65',
                     'A74:D74', 'A77:A77', 'A86:D86', 'A89:A89', 'A98:A98'),
             'N13': ('B7:D13', 'B15:D21', 'B27:C33', 'B35:C41', 'B47:C53',
                     'B55:C61', 'B67:C73', 'B75:C81', 'B88:D92', 'B96:D100',
                     'B106:G106', 'A109:G128', 'D134:D135', 'B139:C140',
                     'B145:C164', 'A172:A172', 'A180:A180', 'A188:A188',
                     'A197:A197'),
            'N14': ('A5:E24', 'A31:A31', 'A37:D56', 'A60:A60'),
            'N15': ('A5:B24', ),
            'N16': ('A6:C25', 'D30:E41', 'A48:A48', 'B57:C58', 'B62:C72',
                    'B76:C78', 'B82:C86', 'B88:C92', 'B96:B97', 'B101:B103',
                    'B107:B115', 'A122:B141', 'A145:B164', 'B168:B169'),
            'N17': ('B5:E6', 'A15:A15', 'A21:B40', 'A46:A46'),
            'N18': ('B6:B10', 'B12:B15', 'A21:C40', 'A44:C63', 'A69:C88',
                    'A94:C113', 'A120:A120'),
            'N19': ('A5:B24', 'B31:F35', 'B37:F41', 'B43:F46', 'B48:F52',
                    'B57:F65', 'A73:A73', 'A81:A81', 'A89:A89', 'A96:A97',
                    'A105:A105', 'A117:C136', 'A143:C162', 'A169:C188',
                     'A195:C214', 'A221:C240', 'A247:C266'),
            'N20': ('A4:A23', 'C4:C23', 'A27:A46', 'C27:C46', 'A50:A50'),
            'N21': ('A4:A4', 'A10:A10')}


RANGES_ECPN = {'ECPN': ('B2:D4', 'F2:H4', 'J2:L4',
                        'B6:D7', 'F6:H7', 'J6:L7',
                        'B9:D13', 'F9:H13', 'J9:L13',
                        'B15:D16', 'F15:H16', 'J15:L16',
                        'B18:D19', 'F18:H19', 'J18:L19',
                        'B21:D24', 'F21:H24', 'J21:L24')}

RANGES_EFE = {'EFE': ('B3:C3', 'B5:C15', 'B17:C22', 'B24:C28', 'B33:C39',
                      'B41:C47','B52:C55', 'B58:C61', 'B63:C66', 'B68:C69',
                       'B72:C72', 'C76:C76')}

RANGES_BAL = {'BAL': ('B5:C8', 'B10:C14', 'B17:C19', 'B21:C23', 'B26:C26',
                      'B28:C32','B34:C36', 'B38:C41', 'B49:C50','B52:C57',
                      'B59:C62', 'B65:C65', 'B67:C71', 'B74:C75', 'B77:C81',
                      'B83:C88')}

RANGES_PIG = {'PIG': ('B4:C8', 'B12:C13', 'B15:C17', 'B19:C21', 'B23:C25',
                      'B27:C32', 'B37:C38', 'B40:C43', 'B45:C46', 'B51:C52',
                      'B54:C54')}
